#!/bin/sh
##########################################################################
# Licensed Materials - Property of IBM
# 5724-T40 IBM License Metric Tool
# 5724-S94 IBM Tivoli Asset Discovery for Distributed
#
# (C) Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
#
# US Government Users Restricted Rights - Use, duplication or
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
##########################################################################

OPTION=$1
BASE_DIR=$2
TIVOLI_COMMON_DIR=$3
BACKUP_REL_DIR=agtbk
BACKUP_DIR=$BASE_DIR$BACKUP_REL_DIR

AGENT_DIR=$BASE_DIR
CONF_FILE_DIR=/etc
STARTUP_SCRIPT_DIR=/etc/init.d
CACHE_REL_DIR=cache
CACHE_DIR=$BASE_DIR$CACHE_REL_DIR
KEYDB_REL_DIR=keydb
KEYDB_DIR=$BASE_DIR$KEYDB_REL_DIR
SCANNER_REL_DIR=scanner
SCANNER_DIR=$BASE_DIR$SCANNER_REL_DIR
UTILITIES_REL_DIR=utilities
UTILITIES_DIR=$BASE_DIR$UTILITIES_REL_DIR

SIGN_FILE1=TLMAGENT0202.sys2
SIGN_FILE2=TLMAGENT0203.sys2
SIGN_FILE3=LMTAGENT0701.SYS2
SIGN_FILE4=LMTTAD4DAGENT0702.SYS2
UNINS_FILE=tlmunins.sh
FFDC_SCRIPT_PATH=COD/scripts/agent/tlmredir.sh

case $OPTION in
-s)
         test -f $AGENT_DIR/tlmagent
	 if [ $? = 0 ]
	 then
		 mv -f $AGENT_DIR/tlmagent $AGENT_DIR/tlmagent.bk
		    if [ $? != 0 ]
		    then
		    exit 2
		    fi	 
	 else
            #for a 2.1/2.2 GA agents
		test -f /usr/sbin/tlmagent
	 	if [ $? = 0 ]
	 	then
			mv -f /usr/sbin/tlmagent /usr/sbin/tlmagent.bk
		    	  if [ $? != 0 ]
		    	  then
		        exit 2
		        fi
            fi
	 fi
	 test -f $AGENT_DIR/tlmagent.bin
	 if [ $? = 0 ]
	 then
		 mv -f $AGENT_DIR/tlmagent.bin $AGENT_DIR/tlmagent.bin.bk
		    if [ $? != 0 ]
		    then
		    exit 17
		    fi	 
	 fi
	 test -f $CONF_FILE_DIR/tlmagent.ini
	 if [ $? = 0 ]
	 then
		 mv -f $CONF_FILE_DIR/tlmagent.ini $CONF_FILE_DIR/tlmagent.ini.bk
		    if [ $? != 0 ]
		    then
		    exit 3
		    fi	 
	 fi
	 test -f $CONF_FILE_DIR/tlm_mobility.cfg
	 if [ $? = 0 ]
	 then
		 mv -f $CONF_FILE_DIR/tlm_mobility.cfg $CONF_FILE_DIR/tlm_mobility.cfg.bk
		    if [ $? != 0 ]
		    then
		    exit 18
		    fi	 
	 fi
	 test -f $CONF_FILE_DIR/tlmlog.properties
	 if [ $? = 0 ]
	 then
		 mv -f $CONF_FILE_DIR/tlmlog.properties $CONF_FILE_DIR/tlmlog.properties.bk
		    if [ $? != 0 ]
		    then
		    exit 4
		    fi	      
	 fi
         test -f $STARTUP_SCRIPT_DIR/tlm
         if [ $? = 0 ]
	 then
             mv -f $STARTUP_SCRIPT_DIR/tlm $STARTUP_SCRIPT_DIR/tlm.bk
		    if [ $? != 0 ]
		    then
		    exit 16
		    fi	      
	 fi
       mkdir $BACKUP_DIR
         test -d $CACHE_DIR
	 if [ $? = 0 ]
	 then
		 cp -Rf $CACHE_DIR $BACKUP_DIR
		    if [ $? != 0 ]
		    then
		    exit 5
		    fi	 
	 fi
         test -d $KEYDB_DIR
	 if [ $? = 0 ]
	 then
		  cp -Rf  $KEYDB_DIR $BACKUP_DIR
		    if [ $? != 0 ]
		    then
		    exit 7
		    fi	 
	 fi
	 test -d $SCANNER_DIR
	 if [ $? = 0 ]
	 then
		 mv -f $SCANNER_DIR $BACKUP_DIR/scanner
		    if [ $? != 0 ]
		    then
		    exit 8
		    fi	 
	 fi
         test -d $UTILITIES_DIR
	 if [ $? = 0 ]
	 then
		 cp -Rf $UTILITIES_DIR $BACKUP_DIR
		    if [ $? != 0 ]
		    then
		    exit 9
		    fi	 
	 fi
	 #SIGN_FILEx
	 test -f $BASE_DIR$SIGN_FILE1
	 if [ $? = 0 ]
	 then
	 mv -f $BASE_DIR$SIGN_FILE1 $BACKUP_DIR
		    if [ $? != 0 ]
		    then
		    exit 11
		    fi	 
	 fi
	 test -f $BASE_DIR$SIGN_FILE2
	 if [ $? = 0 ]
	 then
	 mv -f $BASE_DIR$SIGN_FILE2 $BACKUP_DIR
		    if [ $? != 0 ]
		    then
		    exit 12
		    fi	 
	 fi
	 test -f $BASE_DIR$SIGN_FILE3
	 if [ $? = 0 ]
	 then
	 mv -f $BASE_DIR$SIGN_FILE3 $BACKUP_DIR
		    if [ $? != 0 ]
		    then
		    exit 12
		    fi	 
	 fi	 
	 test -f $BASE_DIR$SIGN_FILE4
	 if [ $? = 0 ]
	 then
	 mv -f $BASE_DIR$SIGN_FILE4 $BACKUP_DIR
		    if [ $? != 0 ]
		    then
		    exit 18
		    fi	 
	 fi	 
	 #UNINS_FILE=tlmunins.sh
	 test -f $BASE_DIR$UNINS_FILE
	 if [ $? = 0 ]
	 then
		 mv -f $BASE_DIR$UNINS_FILE $BACKUP_DIR
		    if [ $? != 0 ]
		    then
		    exit 13
		    fi	 
	 fi
         #FFDC_SCRIPT=tlmredir.sh
         test -f $TIVOLI_COMMON_DIR$FFDC_SCRIPT_PATH
         if [ $? = 0 ]
	 then
		 mv -f $TIVOLI_COMMON_DIR$FFDC_SCRIPT_PATH $TIVOLI_COMMON_DIR$FFDC_SCRIPT_PATH.bk
		    if [ $? != 0 ]
		    then
		    exit 14
		    fi	 
	 fi         
;;
-r)
         test -f $AGENT_DIR/tlmagent.bk
	 if [ $? = 0 ]
	 then
		 mv -f $AGENT_DIR/tlmagent.bk $AGENT_DIR/tlmagent
       else
		#for 2.1/2.2 GA agents
		test -f /usr/sbin/tlmagent.bk
	 	if [ $? = 0 ]
	 	then
			mv -f /usr/sbin/tlmagent.bk /usr/sbin/tlmagent
		fi
	 fi
	 test -f $AGENT_DIR/tlmagent.bin.bk
	 if [ $? = 0 ]
	 then
		 mv -f $AGENT_DIR/tlmagent.bin.bk $AGENT_DIR/tlmagent.bin
	 fi
	 test -f $CONF_FILE_DIR/tlmagent.ini.bk
	 if [ $? = 0 ]
	 then
		 mv -f $CONF_FILE_DIR/tlmagent.ini.bk $CONF_FILE_DIR/tlmagent.ini
	 fi
	 test -f $CONF_FILE_DIR/tlm_mobility.cfg.bk
	 if [ $? = 0 ]
	 then
		 mv -f $CONF_FILE_DIR/tlm_mobility.cfg.bk $CONF_FILE_DIR/tlm_mobility.cfg
	 fi
	 test -f $CONF_FILE_DIR/tlmlog.properties.bk
	 if [ $? = 0 ]
	 then
		 mv -f $CONF_FILE_DIR/tlmlog.properties.bk $CONF_FILE_DIR/tlmlog.properties
	 fi
       test -f $STARTUP_SCRIPT_DIR/tlm.bk
       if [ $? = 0 ]
	 then
             mv -f $STARTUP_SCRIPT_DIR/tlm.bk $STARTUP_SCRIPT_DIR/tlm
       fi
	 #SIGN_FILEx
	 test -f $BACKUP_DIR/$SIGN_FILE1
	 if [ $? = 0 ]
	 then
		 mv -f $BACKUP_DIR/$SIGN_FILE1 $BASE_DIR
	 fi
	 test -f $BACKUP_DIR/$SIGN_FILE2
	 if [ $? = 0 ]
	 then
		 mv -f $BACKUP_DIR/$SIGN_FILE2 $BASE_DIR
	 fi
	 test -f $BACKUP_DIR/$SIGN_FILE3
	 if [ $? = 0 ]
	 then
		 mv -f $BACKUP_DIR/$SIGN_FILE3 $BASE_DIR
	 fi	 
	 test -f $BACKUP_DIR/$SIGN_FILE4
	 if [ $? = 0 ]
	 then
		 mv -f $BACKUP_DIR/$SIGN_FILE4 $BASE_DIR
	 fi	 
         #UNINS_FILE=tlmunins.sh
	 test -f $BACKUP_DIR/$UNINS_FILE
	 if [ $? = 0 ]
	 then
		 mv -f $BACKUP_DIR/$UNINS_FILE $BASE_DIR
	 fi
         #FFDC_SCRIPT=tlmredir.sh
         test -f $TIVOLI_COMMON_DIR$FFDC_SCRIPT_PATH.bk
         if [ $? = 0 ]
	 then
		 mv -f $TIVOLI_COMMON_DIR$FFDC_SCRIPT_PATH.bk $TIVOLI_COMMON_DIR$FFDC_SCRIPT_PATH
	 fi
         
         test -d $BACKUP_DIR
	 if [ $? = 0 ]
	 then
		 cp -Rf $BACKUP_DIR/* $BASE_DIR
                 rm -rf $BACKUP_DIR
	 fi
	 # register the agent as service if tlmagent was present
	 test -f $AGENT_DIR/tlmagent
	 if [ $? = 0 ]
	 then
		 $AGENT_DIR/tlmagent -i > /dev/null
	   else
		#for 2.1/2.2 GA agents
		test -f /usr/sbin/tlmagent
	 	if [ $? = 0 ]
	 	then
			/sbin/chkconfig --add tlm > /dev/null
		fi
	 fi
;;
-c)
       rm -f $AGENT_DIR/tlmagent.bk
       rm -f /usr/sbin/tlmagent.bk
       test -f $AGENT_DIR/tlmagent.bin.bk
       if [ $? = 0 ]
       then
           rm -f $AGENT_DIR/tlmagent.bin.bk
       fi
       rm -f $CONF_FILE_DIR/tlmagent.ini.bk
       rm -f $CONF_FILE_DIR/tlm_mobility.cfg.bk
       rm -f $CONF_FILE_DIR/tlmlog.properties.bk
       rm -f $STARTUP_SCRIPT_DIR/tlm.bk
       rm -rf $BACKUP_DIR
       rm -f $TIVOLI_COMMON_DIR$FFDC_SCRIPT_PATH.bk
;;
*)
       echo Option '$OPTION' not supported
       echo Usage: agent_backup.sh {-s|-r|-c} [agent_base_dir] [tivoli_common_dir]
       exit 10
;;
esac

exit 0
